---
##
# retrieve and configure kolla
#
- hosts: jumphost
  gather_facts: true
  vars_files:
    - "vars/idf.yml"
  tasks:
    # Either we're running this script via a real jumphost and it must have a
    # pub key, either we're not and then pub key must be given via well known
    # variable file.
    - name: get remote id_rsa.pub
      slurp:
        src: "{{ ansible_user_dir }}/.ssh/id_rsa.pub"
      register: id_rsa
      ignore_errors: true

    - name: retrieve pub key
      set_fact:
        pub_key: "{{ id_rsa['content'] | b64decode }}"
      when: not id_rsa.failed

    - name: include vaulted ssh credentials
      include_vars: "{{ inventory_dir }}/../vars/vaulted_ssh_credentials.yml"
      when: id_rsa.failed

    - name: retrieve pub key
      set_fact:
        pub_key: "{{ vault_ssh_id_rsa_pub }}"
      when: id_rsa.failed

- hosts: all
  vars_files:
    - "vars/idf.yml"
  tasks:
    - name: add authorized keys
      authorized_key:
        user: "{{ ansible_user }}"
        state: present
        key: "{{ item }}"
      loop:
        - "{{ hostvars[groups.jumphost.0].pub_key }}"
        - "{{ os_infra.ssh_pub_key_default }}"
      when: inventory_hostname != "jumphost"
